import { default as config } from "../../cfg/config.json";

export const getLevel = (network, user) => {
  let ret = {
    level: 0,
    verified: false
  };
  if (typeof user !== "object")
    return "user has to be an object!";
  if (!user.account || !user.prefix)
    return ret;
  
  let admin;
  if(admin = config.admins.filter(a => 
    a.account === user.account.toLowerCase() &&
    a.network === network.toLowerCase()
  )[0]) {
    ret = {
      level: admin.level,
      verified: user.prefix.toLowerCase() === admin.prefix
    };
  }

  return ret;
};
