import fetch from "flumm-fetch-cookies";
import config from "../../../../cfg/config.json";

export default new class cleverbot {
  constructor() {
    this.api = "https://cleverbot.io/1.0";
    this.nick = "";
    this.init();
  }

  init() {
    const options = {
      method: "POST",
      body: {
        ...config.apis.cleverbot,
        ...{ nick: "uwibot" }
      }
    };
    fetch(`${this.api}/create`, options)
      .then(res => res.json())
      .then(res => this.nick = res.status === "success" ? res.nick: "uwibot")
      .catch(err => console.log(err));
  }

  ask(msg) {
    return new Promise((resolve, reject) => {
      const options = {
        method: "POST",
        body: {
          ...config.apis.cleverbot,
          ...{
            nick: this.nick,
            text: msg
          }
        }
      };
      fetch(`${this.api}/ask`, options)
        .then(res => res.json())
        .then(res => res.status === "success"?resolve(res):reject(res.status))
        .catch(err => reject(err));
    });
  }
};
